/*  drawarea.cpp
 *
 * --------------------------------------------- */

#include <QtGui>

#include "drawarea.h"


DrawArea::DrawArea(QWidget *parent) : QWidget(parent)
{
    setAttribute(Qt::WA_StaticContents);
}


void DrawArea::paintEvent(QPaintEvent * /* event */)
{
    QPainter painter(this);
        
    // void QPainter::drawLine ( int x1, int y1, int x2, int y2 );
    // void QPainter::drawText ( int x, int y, const QString & text );
    // void QPainter::setPen();
    
    painter.setPen( Qt::red );
    painter.drawLine ( 50,  50, 350, 350 );
    painter.drawLine ( 50, 350, 350,  50 );
    
    painter.setPen( Qt::green );
    painter.drawText( 200, 200, "The Center" );
}


    /*  Event handling  */


void DrawArea::resizeEvent(QResizeEvent *event)
{
    if (width() > image.width() || height() > image.height())
    {
        int newWidth = qMax(width() + 128, image.width());
        int newHeight = qMax(height() + 128, image.height());
        resizeImage(&image, QSize(newWidth, newHeight));
        update();
    }

    QWidget::resizeEvent(event);
}


void DrawArea::resizeImage(QImage *image, const QSize &newSize)
{
    if (image->size() == newSize)
        return;

    QImage newImage(newSize, QImage::Format_RGB32);
    newImage.fill(qRgb(255, 255, 255));
    QPainter painter(&newImage);
    painter.drawImage(QPoint(0, 0), *image);
    *image = newImage;
}

